## treeland 0.7.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25.0)

project(Treeland
    VERSION 0.7.0
    LANGUAGES CXX C)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Standard installation paths
include(GNUInstallDirs)
# Macros
include(FeatureSummary)

include(cmake/DefineTarget.cmake)

option(WITH_SUBMODULE_WAYLIB "Use the waylib from git submodule" ON)
add_feature_info(submodule_waylib WITH_SUBMODULE_WAYLIB "Use waylib from submodule")

option(ADDRESS_SANITIZER "Enable address sanitizer" OFF)
add_feature_info(ASanSupport ADDRESS_SANITIZER "https://github.com/google/sanitizers/wiki/AddressSanitizer")

option(BUILD_TREELAND_EXAMPLES "Build clients demo to test treeland" OFF)
add_feature_info(DemoClents BUILD_TEST_CLIENTS "clients demo for testing")

option(DISABLE_DDM "Disable DDM and greeter" OFF)

if (DISABLE_DDM)
    add_compile_definitions("DISABLE_DDM")
endif()

if (ADDRESS_SANITIZER)
    add_compile_options(-fsanitize=address -fno-optimize-sibling-calls -fno-omit-frame-pointer)
    add_link_options(-fsanitize=address)
endif()
# NOTE: Qt keywords conflict with wlroots. but dtksystemsettings still uses it.
# add_definitions("-DQT_NO_KEYWORDS")

# NOTE: Enable Qt logging with context.
add_definitions("-DQT_MESSAGELOGCONTEXT")

set(LOCAL_QML_IMPORT_PATH "${PROJECT_BINARY_DIR}/qt/qml")

if(WITH_SUBMODULE_WAYLIB)
    set(WITH_SUBMODULE_QWLROOTS ON)
    include(${CMAKE_CURRENT_SOURCE_DIR}/qwlroots/cmake/WaylandScannerHelpers.cmake)
    add_subdirectory(waylib)
    list(APPEND LOCAL_QML_IMPORT_PATH "${PROJECT_BINARY_DIR}/waylib/src/server")
else()
    find_package(Waylib REQUIRED Server)
endif()

set(QML_IMPORT_PATH "${LOCAL_QML_IMPORT_PATH}" CACHE STRING "For LSP" FORCE)

# PKG-CONFIG
find_package(PkgConfig REQUIRED)
find_package(Qt6 CONFIG REQUIRED Core DBus Gui Qml Quick QuickControls2 LinguistTools Test QuickTest)

pkg_check_modules(WLROOTS REQUIRED IMPORTED_TARGET wlroots-0.19)

qt_standard_project_setup(REQUIRES 6.8)

# Set constants
set(TREELAND_DATA_DIR           "${CMAKE_INSTALL_DATADIR}/treeland/"               CACHE PATH      "treeland data install directory")
set(TREELAND_COMPONENTS_TRANSLATION_DIR  "${TREELAND_DATA_DIR}/translations"                  CACHE PATH      "Components translations directory")
set(TREELAND_PLUGINS_OUTPUT_PATH   "${CMAKE_BINARY_DIR}/lib/plugins"          CACHE PATH      "treeland plugins output directory")
set(TREELAND_PLUGINS_INSTALL_PATH  "${CMAKE_INSTALL_LIBDIR}/treeland/plugins" CACHE PATH      "treeland plugins install directory")

GNUInstallDirs_get_absolute_install_dir(
    TREELAND_FULL_DATA_DIR
    TREELAND_DATA_DIR
    DATADIR
)

GNUInstallDirs_get_absolute_install_dir(
    TREELAND_FULL_PLUGINS_INSTALL_PATH
    TREELAND_PLUGINS_INSTALL_PATH
    LIBDIR
)

GNUInstallDirs_get_absolute_install_dir(
    TREELAND_FULL_COMPONENTS_TRANSLATION_DIR
    TREELAND_COMPONENTS_TRANSLATION_DIR
    DATADIR
)

add_compile_definitions("TREELAND_DATA_DIR=\"${TREELAND_FULL_DATA_DIR}\"")
# NOTE:: remove force assert before stable version
add_compile_definitions("QT_FORCE_ASSERTS")

add_compile_definitions("TREELAND_PLUGINS_INSTALL_PATH=\"${TREELAND_FULL_PLUGINS_INSTALL_PATH}\"")
add_compile_definitions("TREELAND_PLUGINS_OUTPUT_PATH=\"${TREELAND_PLUGINS_OUTPUT_PATH}\"")

add_compile_definitions("TREELAND_COMPONENTS_TRANSLATION_DIR=\"${TREELAND_FULL_COMPONENTS_TRANSLATION_DIR}\"")

set(PROJECT_RESOURCES_DIR "${CMAKE_SOURCE_DIR}/misc")

enable_testing(true)

add_subdirectory(src)
add_subdirectory(misc)
add_subdirectory(tests)

if (BUILD_TREELAND_EXAMPLES)
    add_subdirectory(examples)
endif()

# Display feature summary
feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== examples/CMakeLists.txt ===
set(MODULE_PATH ${PROJECT_SOURCE_DIR}/src/modules)

add_subdirectory(test_window_bg)
add_subdirectory(test_wallpaper_color)
add_subdirectory(test_show_desktop)
add_subdirectory(test_window_cursor)
add_subdirectory(test_xdgport_wallpaper)
add_subdirectory(test_virtual_output)
add_subdirectory(test_pinch_handler)
add_subdirectory(test_hide_window)
add_subdirectory(test_data_control_manager)
add_subdirectory(test_window_overlapped)
add_subdirectory(test_capture)
add_subdirectory(test_window_appearance)
add_subdirectory(test_super_overlay_surface)
add_subdirectory(test_monitor_active_event)
add_subdirectory(test_primary_output)
add_subdirectory(test_multitaskview)
add_subdirectory(test_set_treeland_wallpaper)

=== misc/CMakeLists.txt ===
add_subdirectory(dbus)
add_subdirectory(dconfig)
add_subdirectory(systemd)
add_subdirectory(wayland-sessions)
add_subdirectory(cmake)

=== qwlroots/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

project(QWlroots
    VERSION 0.5.3
    LANGUAGES CXX C)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

option(PREFER_QT_5 "Prefer to use Qt 5 even if we have Qt 6" OFF)
option(USE_WLROOTS_19 "Use wlroots 0.19 version" ON)
option(QWLROOTS_USE_PERCOMPILE_HEADERS "Use precompile headers to build qwlroots" OFF)
option(DISABLE_WLR_PROTOCOLS "Disable support for wlr protocols, such as wlr-layer-shell" OFF)
option(DISABLE_XWAYLAND "Disable the xwayland support" OFF)

if(PREFER_QT_5)
    find_package(QT NAMES Qt5 REQUIRED COMPONENTS Core)
else()
    find_package(QT NAMES Qt6 QUIET COMPONENTS Core)
    if (NOT QT_FOUND)
        message(FATAL_ERROR "Not found Qt6, set `PREFER_QT_5` option if you want to use Qt5")
    endif()
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
include(PackageVersionHelper)
include(WaylandScannerHelpers)

# For Unix/Linux
include(GNUInstallDirs)

add_subdirectory(src)
enable_testing()
add_subdirectory(tests)
add_subdirectory(examples)

=== src/CMakeLists.txt ===
if(QT_KNOWN_POLICY_QTP0001)
    qt_policy(SET QTP0001 NEW)
    # the RESOURCE_PREFIX argument for qt_add_qml_module() defaults to ":/qt/qml/"
endif()
if(POLICY CMP0071)
    # https://cmake.org/cmake/help/latest/policy/CMP0071.html
    cmake_policy(SET CMP0071 NEW)
endif()

# Include translation utilities
include(${CMAKE_SOURCE_DIR}/cmake/TranslationUtils.cmake)

find_package(Dtk6 REQUIRED COMPONENTS Core Declarative SystemSettings Tools)
if (NOT DISABLE_DDM)
    find_package(DDM 0.2.0  REQUIRED COMPONENTS Auth Common)
endif()
find_package(QT NAMES Qt6 COMPONENTS Core REQUIRED)
find_package(Qt6 CONFIG REQUIRED ShaderTools Concurrent)
find_package(Qt6 COMPONENTS Quick QuickControls2 REQUIRED)
pkg_search_module(PIXMAN REQUIRED IMPORTED_TARGET pixman-1)
pkg_search_module(WAYLAND REQUIRED IMPORTED_TARGET wayland-server)
pkg_search_module(LIBINPUT REQUIRED IMPORTED_TARGET libinput)
pkg_search_module(XCB REQUIRED IMPORTED_TARGET xcb)
pkg_check_modules(PAM REQUIRED IMPORTED_TARGET pam)
# qt_finalize_target will collect all executable's private dependencies that are CMake targets

qt_add_dbus_adaptor(DBUS_ADAPTOR "${CMAKE_SOURCE_DIR}/misc/dbus/org.deepin.compositor1.xml" "core/treeland.h" Treeland::Treeland)

set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.DisplayManager.xml" PROPERTIES
    NO_NAMESPACE ON
    CLASSNAME DisplayManager
)
set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.DisplayManager.Seat.xml" PROPERTIES
    NO_NAMESPACE ON
    CLASSNAME DisplaySeat
)

set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.DisplayManager.Session.xml" PROPERTIES
    NO_NAMESPACE ON
    CLASSNAME DisplaySession
)

set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.Manager.xml" PROPERTIES
   INCLUDE "loginddbustypes.h"
)
set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.Seat.xml" PROPERTIES
   INCLUDE "loginddbustypes.h"
)

set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.Session.xml" PROPERTIES
   INCLUDE "loginddbustypes.h"
)

set_source_files_properties("${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.User.xml" PROPERTIES
   INCLUDE "loginddbustypes.h"
)

qt_add_dbus_interface(DDM_DBUS_SOURCES "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.DisplayManager.xml"          DisplayManager)
qt_add_dbus_interface(DDM_DBUS_SOURCES "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.DisplayManager.Seat.xml"     DisplayManagerSeat)
qt_add_dbus_interface(DDM_DBUS_SOURCES "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.DisplayManager.Session.xml"  DisplayManagerSession)
qt_add_dbus_interface(DDM_DBUS_SOURCES "${CMAKE_SOURCE_DIR}/misc/interfaces/org.deepin.DisplayManager.xml"               DDMDisplayManager)
qt_add_dbus_interface(DBUS_INTERFACE   "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.Manager.xml"          Login1Manager)
qt_add_dbus_interface(DBUS_INTERFACE   "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.Seat.xml"             Login1Seat)
qt_add_dbus_interface(DBUS_INTERFACE   "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.Session.xml"          Login1Session)
qt_add_dbus_interface(DBUS_INTERFACE   "${CMAKE_SOURCE_DIR}/misc/interfaces/org.freedesktop.login1.User.xml"             Login1User)

dtk_add_config_to_cpp(
    TREELAND_CONFIG
    "${PROJECT_SOURCE_DIR}/misc/dconfig/org.deepin.treeland.json"
    OUTPUT_FILE_NAME "treelandconfig.hpp"
    CLASS_NAME "TreelandConfig"
)

qt_add_library(libtreeland SHARED)

set_target_properties(libtreeland PROPERTIES
    OUTPUT_NAME "treeland"
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
)

qt_add_qml_module(libtreeland
    URI Treeland
    VERSION "2.0"

    SOURCES
        ${DBUS_ADAPTOR}
        ${DDM_DBUS_SOURCES}
        ${DBUS_INTERFACE}
        ${TREELAND_CONFIG}
        common/treelandlogging.cpp
        common/treelandlogging.h
        core/layersurfacecontainer.cpp
        core/layersurfacecontainer.h
        core/popupsurfacecontainer.cpp
        core/popupsurfacecontainer.h
        core/qmlengine.cpp
        core/qmlengine.h
        core/rootsurfacecontainer.cpp
        core/rootsurfacecontainer.h
        core/shellhandler.cpp
        core/shellhandler.h
        core/treeland.cpp
        core/treeland.h
        core/windowpicker.cpp
        core/windowpicker.h
        effects/tquickradiuseffect.cpp
        effects/tquickradiuseffect.h
        effects/tquickradiuseffect_p.h
        effects/tsgradiusimagenode.cpp
        effects/tsgradiusimagenode.h
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:core/lockscreen.h>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:core/lockscreen.cpp>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/greeterproxy.cpp>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/greeterproxy.h>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/sessionmodel.cpp>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/sessionmodel.h>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/user.cpp>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/user.h>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/usermodel.cpp>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:greeter/usermodel.h>
        input/gestures.cpp
        input/gestures.h
        input/inputdevice.cpp
        input/inputdevice.h
        input/togglablegesture.cpp
        input/togglablegesture.h
        interfaces/baseplugininterface.h
        interfaces/lockscreeninterface.h
        interfaces/multitaskviewinterface.h
        interfaces/plugininterface.h
        interfaces/proxyinterface.h
        output/output.cpp
        output/output.h
        seat/helper.cpp
        seat/helper.h
        surface/surfacecontainer.cpp
        surface/surfacecontainer.h
        surface/surfacefilterproxymodel.cpp
        surface/surfacefilterproxymodel.h
        surface/surfaceproxy.cpp
        surface/surfaceproxy.h
        surface/surfacewrapper.cpp
        surface/surfacewrapper.h
        utils/cmdline.cpp
        utils/cmdline.h
        utils/propertymonitor.cpp
        utils/propertymonitor.h
        utils/loginddbustypes.h
        utils/loginddbustypes.cpp
        wallpaper/wallpapercontroller.cpp
        wallpaper/wallpapercontroller.h
        wallpaper/wallpaperimage.cpp
        wallpaper/wallpaperimage.h
        wallpaper/wallpapermanager.cpp
        wallpaper/wallpapermanager.h
        workspace/workspace.cpp
        workspace/workspace.h
        workspace/workspaceanimationcontroller.cpp
        workspace/workspaceanimationcontroller.h
        workspace/workspacemodel.cpp
        workspace/workspacemodel.h

    QML_FILES
        core/qml/PrimaryOutput.qml
        core/qml/CopyOutput.qml
        core/qml/TitleBar.qml
        core/qml/Decoration.qml
        core/qml/WindowMenu.qml
        core/qml/TaskBar.qml
        core/qml/SurfaceContent.qml
        core/qml/XdgShadow.qml
        core/qml/Border.qml
        core/qml/OutputMenuBar.qml
        core/qml/WorkspaceSwitcher.qml
        core/qml/WorkspaceProxy.qml
        core/qml/Animations/GeometryAnimation.qml
        core/qml/Animations/NewAnimation.qml
        core/qml/Animations/MinimizeAnimation.qml
        core/qml/Animations/ShowDesktopAnimation.qml
        core/qml/Animations/LaunchpadAnimation.qml
        core/qml/Animations/LayerShellAnimation.qml
        core/qml/Effects/Blur.qml
        core/qml/Effects/LaunchpadCover.qml
        core/qml/TaskSwitcher.qml
        core/qml/TaskWindowPreview.qml
        core/qml/SwitchViewDelegate.qml
        core/qml/SwitchViewHighlightDelegate.qml
        core/qml/DockPreview.qml
        core/qml/FadeBehavior.qml
        core/qml/CaptureSelectorLayer.qml
        core/qml/WindowPickerLayer.qml
    RESOURCE_PREFIX
        /qt/qml
    OUTPUT_DIRECTORY
        ${PROJECT_BINARY_DIR}/qt/qml/Treeland
)

target_compile_definitions(libtreeland
    PRIVATE
    WLR_USE_UNSTABLE
)

qt_add_shaders(libtreeland "treeland_shaders_ng"
    BATCHABLE
    PRECOMPILE
    PREFIX
        "/shaders"
    BASE
        ${PROJECT_RESOURCES_DIR}/shaders
    FILES
        ${PROJECT_RESOURCES_DIR}/shaders/radiussmoothtexture.vert
        ${PROJECT_RESOURCES_DIR}/shaders/radiussmoothtexture.frag
)

qt_add_resources(libtreeland "treeland_assets"
    PREFIX "/dsg/icons"
    BASE ${PROJECT_RESOURCES_DIR}/icons
    FILES
        ${PROJECT_RESOURCES_DIR}/icons/close.dci
        ${PROJECT_RESOURCES_DIR}/icons/add.dci
        ${PROJECT_RESOURCES_DIR}/icons/select_output.dci
        ${PROJECT_RESOURCES_DIR}/icons/select_window.dci
        ${PROJECT_RESOURCES_DIR}/icons/select_region.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_capslock.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_display_password.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_hidden_password.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_keyboard.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_lock.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_open.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_power.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_reboot.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_hibernate.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_user.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_hint.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_logout.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_shutdown.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_suspend.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_switchuser.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_update_reboot.dci
        ${PROJECT_RESOURCES_DIR}/icons/login_update_shutdown.dci
        ${PROJECT_RESOURCES_DIR}/icons/backToLightdm.dci
        ${PROJECT_RESOURCES_DIR}/icons/logo.svg
)

# Use translation utilities to setup main translations
setup_main_translations(libtreeland)

target_include_directories(libtreeland
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>
        $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/src>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/config>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/core>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/effects>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/greeter>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/input>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/interfaces>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/output>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/seat>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/surface>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/workspace>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/utils>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/wallpaper>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/treeland>
)

target_link_libraries(libtreeland
    PUBLIC
        Dtk6::Core
        Dtk6::Declarative
        Dtk6::SystemSettings
        Waylib::WaylibServer
    PRIVATE
        Qt6::Quick
        Qt6::QuickControls2
        Qt6::QuickPrivate
        Qt6::DBus
        Qt6::Concurrent
        PkgConfig::PIXMAN
        PkgConfig::WAYLAND
        PkgConfig::LIBINPUT
        PkgConfig::XCB
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:DDM::Auth>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:DDM::Common>
        $<$<NOT:$<BOOL:${DISABLE_DDM}>>:PkgConfig::PAM>
)

add_subdirectory(plugins)
add_subdirectory(modules)
add_subdirectory(treeland-shortcut)

set(BIN_NAME treeland)

qt_add_executable(${BIN_NAME}
    main.cpp
)

target_include_directories(${BIN_NAME} PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/core/>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/interfaces/>
)

target_link_libraries(${BIN_NAME} PRIVATE
    libtreeland
)

install(TARGETS ${BIN_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
install(PROGRAMS treeland.sh DESTINATION "${CMAKE_INSTALL_BINDIR}")
install(TARGETS libtreeland LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")

## systemd socket

=== tests/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

add_subdirectory(test_protocol_personalization)
add_subdirectory(test_protocol_primary-output)
add_subdirectory(test_protocol_shortcut)
add_subdirectory(test_protocol_virtual-output)
add_subdirectory(test_protocol_wallpaper-color)
add_subdirectory(test_protocol_window-management)

=== waylib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.21)

project(Waylib
    VERSION 0.6.13
    LANGUAGES CXX C)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

option(WITH_SUBMODULE_QWLROOTS "Use the QWlroots from git submodule" ON)
option(BUILD_EXAMPLES "A minimum viable product Wayland compositor based on waylib and other examples" ON)
option(BUILD_TESTS "Build test demos" ON)
option(DISABLE_XWAYLAND "Disable the xwayland support" OFF)
# Don't install tinywl by default, using for debug in local
option(INSTALL_TINYWL "A minimum viable product Wayland compositor based on waylib" OFF)
option(ADDRESS_SANITIZER "Enable address sanitize" OFF)
option(WAYLIB_USE_PERCOMPILE_HEADERS "Use precompile headers to build waylib" OFF)

set(QT_COMPONENTS Core Gui Quick)
find_package(Qt6 COMPONENTS ${QT_COMPONENTS} REQUIRED)
if(WITH_SUBMODULE_QWLROOTS)
    # Use qwlroots from project root directory
    include(${CMAKE_SOURCE_DIR}/qwlroots/cmake/WaylandScannerHelpers.cmake)
    add_subdirectory(${CMAKE_SOURCE_DIR}/qwlroots qwlroots)
    message("Using QWlroots from submodule")
else()
    find_package(QWlroots REQUIRED)
endif()

if(DISABLE_XWAYLAND)
    add_definitions(-DDISABLE_XWAYLAND)
endif()

if (ADDRESS_SANITIZER)
    add_compile_options(-fsanitize=address -fno-optimize-sibling-calls -fno-omit-frame-pointer)
    add_link_options(-fsanitize=address)
endif()

# For Unix/Linux
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
include(PackageVersionHelper)

add_subdirectory(src)
if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()
if(BUILD_TESTS)
    enable_testing(true)
    add_subdirectory(tests)
endif()

=== examples/test_pinch_handler/CMakeLists.txt ===
set(BIN_NAME test-pinch-handler)

find_package(Qt6 REQUIRED COMPONENTS Quick)

qt_add_executable(${BIN_NAME}
    main.cpp
)

qt_add_qml_module(${BIN_NAME}
    URI pinchhandler
    VERSION 1.0
    QML_FILES Main.qml
    SOURCES eventitem.cpp
)

target_link_libraries(${BIN_NAME}
    PRIVATE Qt6::Quick
)

install(TARGETS ${BIN_NAME}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== examples/test_set_treeland_wallpaper/CMakeLists.txt ===
find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core)
find_package(Qt6 REQUIRED COMPONENTS WaylandClient Quick Core Gui)
find_package(Dtk6 REQUIRED COMPONENTS Declarative)
find_package(TreelandProtocols REQUIRED)
find_package(PkgConfig REQUIRED)
pkg_get_variable(WAYLAND_PROTOCOLS wayland-protocols pkgdatadir)

# Include translation utilities
include(${CMAKE_SOURCE_DIR}/cmake/TranslationUtils.cmake)

set(BIN_NAME test-set-treeland-wallpaper)

qt_add_executable(${BIN_NAME}
    main.cpp
)

qt_generate_wayland_protocol_client_sources(${BIN_NAME}
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-personalization-manager-v1.xml
)

set(QML_FILES
    main.qml
    Wallpaper.qml
    WallpaperCard.qml
    WallpaperSetting.qml
    PropertyItemDelegate.qml
)

qt_add_qml_module(${BIN_NAME}
    URI Wallpaper
    VERSION "1.0"
    SOURCES
    personalizationmangerclient.cpp
    personalizationmangerclient.h
    wallpapercardmodel.cpp
    wallpapercardmodel.h
    QML_FILES ${QML_FILES}
    SOURCES imagehelper.h imagehelper.cpp
)

# Use translation utilities to setup translations
setup_translations(${BIN_NAME} wallpaper)

target_link_libraries(${BIN_NAME}
    PRIVATE
        Qt6::Gui
        Qt6::WaylandClient
        Dtk6::Declarative
)

install(TARGETS ${BIN_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== examples/test_super_overlay_surface/CMakeLists.txt ===
find_package(Qt6 REQUIRED COMPONENTS WaylandClient Widgets)
find_package(TreelandProtocols REQUIRED)

set(BIN_NAME test-super-overlay-surface)

qt_add_executable(${BIN_NAME}
    main.cpp
    ddeshellwayland.h ddeshellwayland.cpp
    ddeshelsurfacewindow.h ddeshelsurfacewindow.cpp
)

qt_generate_wayland_protocol_client_sources(${BIN_NAME}
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-dde-shell-v1.xml
)

target_link_libraries(${BIN_NAME}
    PRIVATE
        Qt6::Gui
        Qt6::Widgets
        Qt6::WaylandClient
        Qt6::WaylandClientPrivate
)

install(TARGETS ${BIN_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== examples/test_wallpaper_color/CMakeLists.txt ===
find_package(Qt6 REQUIRED COMPONENTS Core Gui WaylandClient)
find_package(TreelandProtocols REQUIRED)

set(BIN_NAME test-wallpaper-color)

qt_add_executable(${BIN_NAME}
    main.cpp
)

qt_generate_wayland_protocol_client_sources(${BIN_NAME}
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-wallpaper-color-v1.xml
)

target_link_libraries(${BIN_NAME}
    PRIVATE
        Qt6::Gui
        Qt6::WaylandClient
)

install(TARGETS ${BIN_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== examples/test_window_bg/CMakeLists.txt ===
find_package(Qt6 REQUIRED COMPONENTS WaylandClient Widgets)
find_package(TreelandProtocols REQUIRED)

set(BIN_NAME test-window-bg)

qt_add_executable(${BIN_NAME}
    main.cpp
)

qt_generate_wayland_protocol_client_sources(${BIN_NAME}
    FILES
        ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-personalization-manager-v1.xml
)

target_link_libraries(${BIN_NAME}
    PRIVATE
        Qt6::Gui
        Qt6::Widgets
        Qt6::WaylandClient
        Qt6::GuiPrivate
        Qt6::WaylandClientPrivate
)

install(TARGETS ${BIN_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== debian/changelog ===
treeland (0.7.3) unstable; urgency=medium

  * fix: fix WorkspaceSelectionList animation's highlight border size
  * fix: fix MultitaskView display problem
  * refactor: reduce cursor-related log verbosity
  * fix: fix MultitaskView display problem caused by refactoring
    TreelandConfig
  * Updates for project TreeLand (#563)

 -- rewine <luhongxu@uniontech.com>  Tue, 23 Sep 2025 17:24:35 +0800

treeland (0.7.2) unstable; urgency=medium

  * fix: crash on startup due to uninitialized m_config pointer

 -- rewine <luhongxu@uniontech.com>  Fri, 19 Sep 2025 10:06:51 +0800

treeland (0.7.1) unstable; urgency=medium

  * fix: Fix socket blocking issue in Wayland server connection handling
  * fix: correct window title visibility condition
  * fix: Fix client crash when created via security context
  * feat: add security-context support
  * fix: Separate DConfig object creation to another thread to avoid
    blocking
  * fix: move DBus call to separate thread to avoid blocking
  * fix: fixing some trivial memory management bugs.
  * feat(core): Add support for XDG toplevel surface and XDG shell in
    RootSurfaceContainer
  * fix: correct refresh rate on multi-monitor
  * fix: redraw when frame callback list updates

 -- rewine <luhongxu@uniontech.com>  Thu, 18 Sep 2025 11:46:00 +0800

treeland (0.7.0) unstable; urgency=medium

  * fix: fix treeland get stuck in lockscreen after crash recovery
  * fix: occasional crash during stop preview item handling
  * refactor: improve code robustness
  * fix: occasional crash when closing x window
  * fix: resolve brief black screen during standby
  * chore: remove dde portal screen cast configuration
  * fix: correct log category and add null check for surface activation
  * fix: resolve window resize crash during image capture
  * fix: fix wrong display render issue when switching VT too quickly
  * Totally disable lockscreen animation when switching TTY to prevent
    stuck for switching too quickly
  * feat: Support TTY switching with DDM
  * Updates for project TreeLand (#515)
  * feat(waylib): add WBufferDumper utility for dumping buffer contents
    to image files
  * refactor: use unified CI build preset with Werror
  * build: enable -Werror compiler flag
  * fix: prevent crash during preview item handling (#512)
  * fix: prevent cursor flicker during screen recording
  * docs: add comprehensive logging guidelines and update module logging
  * feat: add centralized logging system and standardize log usage
  * feat: ssd title bar displays the window title information
  * fix: maximize/restore icon in the SSD title bar displays incorrectly
  * fix: resolve multiple compiler warnings
  * fix(waylib): prevent duplicate signal connections using
    Qt::UniqueConnection
  * fix(waylib): prevent crash by safely managing textureChanged
    connection
  * fix: use exec to replace process and avoid duplicate logs in
    treeland.sh
  * fix(waylib): Occasional crash when moving the cursor

 -- rewine <luhongxu@uniontech.com>  Fri, 29 Aug 2025 10:23:45 +0800

treeland (0.6.2) unstable; urgency=medium

  * fix: resolve library versioning and installation path issues

 -- rewine <luhongxu@uniontech.com>  Mon, 04 Aug 2025 17:42:40 +0800

treeland (0.6.1) unstable; urgency=medium

  * fix: improve D-Bus connection handling and QML hover visibility
  * feat: CLI option: switch from --disable-debug-view to --enable-debug-
    view
  * fix(waylib): Specify required rendering flags in
    WSGRenderFootprintNode

 -- rewine <luhongxu@uniontech.com>  Fri, 01 Aug 2025 13:33:07 +0800

treeland (0.6.0) unstable; urgency=medium

  * fix: improve image capture error handling and code structure
  * feat: add foreign toplevel image capture support
  * feat: add image capture source support
  * fix: remove unused quit full button and add helper activation
  * fix: prevent title bar and window buttons from stealing focus
  * feat: add wl_drm support
  * feat: create ext-data-control manager
  * fix: Handle VT switching keys (#469)
  * feat: add Nix flake support for project configuration
  * fix: prevent workspace moveSurfaceTo crash on null wrapper
  * fix: remove redundant submodule options and configs
  * chore: update nix dependencies and clean up configurations
  * fix: Scaling animation not shown while return from shutdown page
  * chore: Force Ninja build during deb packaging
  * fix: add timeout to protocol tests
  * feat: Upload build artifacts as zip archives
  * chore: fix CI and enable independent builds
  * refactor: merge qwlroots and waylib source code into treeland
  * chore: Use treeland-specific seatd service
  * feat: implement ext-foreign-toplevel-list
  * i18n: Updates for project TreeLand (#440)
  * chore: remove polkit rules for login1
  * feat: add support for alpha modifier protocol
  * fix: cannot export dbus services
  * Revert "fix: should not maximize when client set maxsize"
  * Updates for project TreeLand (#431)
  * fix: Treeland does not exit when logging out of session
  * fix: cannot use treeland user session mode
  * fix: add [[maybe_unused]] attribute to unused parameters
  * chore: improvement fixes the translation configuration
  * feat: add popup surface container for handling popup windows
  * chore: configure translation files and update Chinese translations
  * chore: configure transifex translation files
  * feat: adapt to wlroots-0.19
  * refactor: remove jemalloc dependency

 -- rewine <luhongxu@uniontech.com>  Thu, 31 Jul 2025 20:40:50 +0800

treeland (0.5.21) unstable; urgency=medium

  * fix: inputted password and capsIndicator button are covered

 -- rewine <luhongxu@deepin.org>  Thu, 17 Apr 2025 15:17:48 +0800

=== qwlroots/debian/changelog ===
qwlroots (0.5.4) unstable; urgency=medium

  * feat: update wlroots and nixpkgs versions for qwlroots
  * Improve the intelligence of cursor addition encapsulation
  * Add wlroots 0.19 render types and protocol support
  * fix: correct typo in build command description
  * docs: add documentation for AI development
  * chore: update gitignore for IDE environments
  * ci: pin wlroots to 0.18 for Arch Linux GitHub Actions build
  * Make the existing interface compatible with wlroots-0.19

 -- rewine <luhongxu@deepin.org>  Mon, 23 Jun 2025 17:34:11 +0800

qwlroots (0.5.3) unstable; urgency=medium

  * Implement qw_idle_inhibitor_v1
  * Do not explicitly build static lib

 -- rewine <luhongxu@deepin.org>  Thu, 20 Feb 2025 17:40:48 +0800

=== debian/control ===
Source: treeland
Priority: optional
Maintainer: rewine <luhongxu@deepin.org>
Build-Depends: cmake (>= 3.4~),
               debhelper-compat (= 13),
               ninja-build,
               extra-cmake-modules (>= 1.4.0~),
               libddm-dev,
               libdtk6core-bin,
               libdtk6core-dev,
               libdtk6declarative-dev,
               libdtk6gui-dev,
               libdtk6systemsettings-dev,
               libdtkcommon-dev,
               libsystemd-dev [linux-any],
               systemd,
               libwlroots-0.19-dev,
               libpixman-1-dev,
               libxcb-ewmh-dev,
               libdrm-dev,
               pkg-config,
               qml6-module-qtquick-templates,
               qt6-base-dev (>= 6.6.1~),
               qt6-base-private-dev (>= 6.6.1~),
               qt6-base-dev-tools (>= 6.6.0),
               qt6-declarative-dev (>= 6.6.1~),
               qt6-declarative-private-dev (>= 6.6.0),
               qt6-shadertools-dev,
               qt6-tools-dev,
               qt6-tools-dev-tools (>= 6.6.1~),
               qt6-wayland,
               qt6-wayland-dev,
               qt6-wayland-private-dev,
               wayland-protocols,
               wlr-protocols,
               treeland-protocols,
               libpam0g-dev,
Standards-Version: 4.6.0
Section: dde
Homepage: https://github.com/linuxdeepin/treeland.git
#Vcs-Browser: https://salsa.debian.org/debian/treeland
#Vcs-Git: https://salsa.debian.org/debian/treeland.git
Rules-Requires-Root: no

Package: treeland
Section: dde
Architecture: any
Multi-Arch: same
Depends: qml6-module-qtquick-layouts,
         qml6-module-qtquick-particles,
         treeland-data (= ${source:Version}),
         xwayland,
         ${shlibs:Depends},
Conflicts: libwaylib, qwlroots
Replaces: libwaylib, qwlroots
Recommends: ddm,
Description: a Wayland compositor based on wlroots and QML, designed with an attractive and elegant appearance.

Package: treeland-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, treeland( =${source:Version}),
Conflicts: libwaylib-dev, qwlroots
Replaces: libwaylib-dev, qwlroots
Description: a Wayland compositor based on wlroots and QML, designed with an attractive and elegant appearance.

Package: treeland-examples
Section: dde
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
Description: examples for treeland.

Package: treeland-data
Section: dde
Architecture: all
Depends: ${misc:Depends},
Description: data files of treeland.

Package: treeland-wayland-session
Section: dde
Architecture: all
Depends: ${misc:Depends},
         treeland (= ${source:Version}),
Description: treeland user session files of treeland.

=== qwlroots/debian/control ===
Source: qwlroots
Priority: optional
Maintainer: rewine <lhongxu@outlook.com>
Build-Depends: debhelper-compat (= 13),
               pkg-config,
               cmake,
               ninja-build,
               qt6-base-private-dev,
               qt6-base-dev-tools,
               wayland-protocols,
               wlr-protocols,
               libwlroots-0.19-dev,
               libpixman-1-dev,
               libxcb-ewmh-dev,
               libdrm-dev
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/vioken/qwlroots.git
#Vcs-Browser: https://salsa.debian.org/debian/qwlroots
#Vcs-Git: https://salsa.debian.org/debian/qwlroots.git
Rules-Requires-Root: no

Package: qwlroots
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
  ${misc:Depends},
  libwlroots-0.19-dev
Replaces: libqwlroots1
Description: Qt and QML bindings for wlroots
  qwlroots is a binding of wlroots, which provides a Qt style development interface.
 It aims to simplify wlroots API calling methods with Qt, and serve the needs of
 calling wlroots within Qt projects.
 .
 This package contains the development headers and static library.

=== waylib/debian/control ===
Source: waylib
Section: libdevel
Priority: optional
Maintainer: JiDe Zhang <zhangjide@deepin.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               ninja-build,
               libpixman-1-dev,
               libwlroots-0.19-dev,
               libxcb-ewmh-dev,
               pkg-config,
               qml6-module-qtquick-templates,
               qt6-base-dev-tools (>= 6.6.0),
               qt6-base-private-dev (>= 6.6.0),
               qt6-declarative-private-dev (>= 6.6.0),
               qwlroots,
               wayland-protocols,
               wlr-protocols,
Standards-Version: 3.9.8

Package: libwaylib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Multi-Arch: same
Description:  A wrapper for wlroots based on Qt
 .
 This package contains the shared libraries.

Package: libwaylib-dev
Architecture: any
Depends: libwaylib (=${binary:Version}),
         libwlroots-0.19-dev,
         qt6-base-dev-tools (>= 6.6.0),
         qt6-base-private-dev (>= 6.6.0),
         qt6-declarative-private-dev (>= 6.6.0),
         wlr-protocols,
         ${misc:Depends},
         ${shlibs:Depends},
Description: A devel package for libwaylib
 .
 This package contains the header files and static libraries of waylib.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
# export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --preset deb

=== qwlroots/debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@


# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
override_dh_auto_configure:
	dh_auto_configure -- \
	-GNinja \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

=== waylib/debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk
export QT_SELECT = qt6

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -GNinja -DCMAKE_INSTALL_PREFIX=/usr

#override_dh_auto_test:
#	echo "skip auto test"

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info
